From 72bf0c548abd2038b32e985d1568cf71d24bc007 Mon Sep 17 00:00:00 2001
From: David Curry <david.curry@totaralms.com>
Date: Tue, 24 Jun 2014 09:48:30 +1200
Subject: [PATCH] T-11185 appraisal: Add support for dynamic changes to
 assignments

Change-Id: Ia007149e3c6f39c61d0f2fa49089baeef12ce20a
---
 totara/appraisal/activation.php                    |   4 +-
 totara/appraisal/classes/observer.php              | 135 ++++
 totara/appraisal/cron.php                          |  13 +-
 totara/appraisal/db/events.php                     |   9 +-
 totara/appraisal/db/install.xml                    |  19 +-
 totara/appraisal/db/upgrade.php                    | 135 ++--
 totara/appraisal/general.php                       |   4 +
 totara/appraisal/lang/en/totara_appraisal.php      |  28 +-
 totara/appraisal/learners.php                      |  79 +-
 totara/appraisal/lib.php                           | 828 +++++++++++++++------
 totara/appraisal/lib/assign/ajax.php               |  25 +-
 totara/appraisal/lib/assign/lib.php                |  79 +-
 totara/appraisal/message.php                       |   7 +-
 totara/appraisal/missing.php                       |  72 ++
 .../rb_sources/lang/en/rb_source_appraisal.php     |   8 +
 .../appraisal/rb_sources/rb_source_appraisal.php   |  52 +-
 totara/appraisal/renderer.php                      | 250 ++++++-
 totara/appraisal/snapshot.php                      |  59 +-
 totara/appraisal/stage.php                         |   4 +
 totara/appraisal/styles.css                        |  15 +
 totara/appraisal/tests/appraisal_test.php          | 589 ++++++++++++++-
 totara/appraisal/tests/message_test.php            |   2 +-
 totara/appraisal/version.php                       |   2 +-
 totara/core/lib/assign/assigngroup_dialog.js       |  13 +-
 totara/core/lib/assign/groups/cohort.class.php     |  18 +
 totara/core/lib/assign/hierarchy.class.php         |  18 +
 totara/core/lib/assign/lib.php                     | 196 ++++-
 27 files changed, 2184 insertions(+), 479 deletions(-)
 create mode 100644 totara/appraisal/classes/observer.php
 create mode 100644 totara/appraisal/missing.php

diff --git a/totara/appraisal/activation.php b/totara/appraisal/activation.php
index 30344e8..e9f352e 100644
--- a/totara/appraisal/activation.php
+++ b/totara/appraisal/activation.php
@@ -45,7 +45,7 @@ $appraisal = new appraisal($id);
 
 switch ($action) {
     case 'activate':
-        $errors = $appraisal->validate();
+        list($errors, $warnings) = $appraisal->validate();
         if (empty($errors) && $confirm) {
             if (!confirm_sesskey()) {
                 print_error('confirmsesskeybad', 'error');
@@ -86,7 +86,7 @@ echo $output->header();
 switch ($action) {
     case 'activate':
         echo $output->heading($appraisal->name);
-        echo $output->confirm_appraisal_activation($appraisal, $errors);
+        echo $output->confirm_appraisal_activation($appraisal, $errors, $warnings);
         break;
     case 'close':
         echo $output->heading(get_string('closeappraisal', 'totara_appraisal'));
diff --git a/totara/appraisal/classes/observer.php b/totara/appraisal/classes/observer.php
new file mode 100644
index 0000000..972c73c
--- /dev/null
+++ b/totara/appraisal/classes/observer.php
@@ -0,0 +1,135 @@
+<?php
+/*
+ * This file is part of Totara LMS
+ *
+ * Copyright (C) 2010 onwards Totara Learning Solutions LTD
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * @author David Curry <david.curry@totaralms.com>
+ * @package totara
+ * @subpackage appraisal
+ */
+
+defined('MOODLE_INTERNAL') || die();
+
+class totara_appraisal_observer {
+
+    /**
+     * Event that is triggered when a user is deleted.
+     *
+     * Checks for any appraisals roles the user may have had and archives them.
+     *
+     * @param \core\event\user_deleted $event
+     *
+     */
+    public static function user_deleted(\core\event\user_deleted $event) {
+        global $CFG, $DB;
+        require_once($CFG->dirroot . '/totara/appraisal/lib.php');
+
+        $userid = $event->objectid;
+        $transaction = $DB->start_delegated_transaction();
+
+        // Delete all user_assignments and associated data for the user.
+        appraisal::delete_learner_assignments($userid);
+
+        // Unassign all role_assignments for the user, but retain associated data.
+        appraisal::unassign_user_roles($userid);
+
+        $transaction->allow_commit();
+    }
+
+    /**
+     * Activation message handler
+     * If message is not immediate - add scheduled event
+     * Also process stage_due as technically it's not an event but scheduled action
+     *
+     * @param \totara_appraisal\event\appraisal_activation $event
+     */
+    public static function appraisal_activation(\totara_appraisal\event\appraisal_activation $event) {
+        global $DB, $CFG;
+
+        require_once($CFG->dirroot . '/totara/appraisal/lib.php'); // We should move all the classes into self loading ones.
+
+        $time = $event->other['time'];
+        $appraisalid = $event->objectid;
+
+        $sql = "SELECT id FROM {appraisal_event} WHERE triggered = 0 AND event IN (?, ?) AND appraisalid = ?";
+        $params = array(appraisal_message::EVENT_APPRAISAL_ACTIVATION, appraisal_message::EVENT_STAGE_DUE, $appraisalid);
+        $events = $DB->get_records_sql($sql, $params);
+        foreach ($events as $id => $eventdata) {
+            $eventmessage = new appraisal_message($id);
+            self::process_event($eventmessage, $time);
+        }
+    }
+
+    /**
+     * Stage complete message handler
+     *
+     * @param \totara_appraisal\event\appraisal_stage_completion $event
+     */
+    public static function appraisal_stage_completion(\totara_appraisal\event\appraisal_stage_completion $event) {
+        global $DB, $CFG;
+
+        require_once($CFG->dirroot . '/totara/appraisal/lib.php'); // We should move all the classes into self loading ones.
+
+        $time = $event->other['time'];
+        $stageid = $event->other['stageid'];
+        $sql = "SELECT id FROM {appraisal_event} WHERE triggered = 0 AND event = ? AND appraisalstageid = ?";
+        $params = array(appraisal_message::EVENT_STAGE_COMPLETE, $stageid);
+        $events = $DB->get_records_sql($sql, $params);
+        foreach ($events as $id => $eventdata) {
+            self::process_event(new appraisal_message($id), $time);
+        }
+    }
+
+    /**
+     * Send or schedule messages according time and settings
+     *
+     * @param appraisal_message $event
+     * @param int $time
+     */
+    protected static function process_event(appraisal_message $event, $time) {
+        if ($event->is_immediate()) {
+            $event->send();
+        } else {
+            $event->schedule($event->get_schedule_from($time));
+            $event->save();
+        }
+    }
+
+
+    /**
+     * Get's all scheduled untriggered messages and send's them
+     *
+     * @param int $time current time
+     */
+    public static function send_scheduled($time) {
+        global $DB, $CFG;
+
+        require_once($CFG->dirroot . '/totara/appraisal/lib.php'); // We should move all the classes into self loading ones.
+
+        $sql = "SELECT ae.id
+                FROM {appraisal_event} ae JOIN {appraisal} a ON (ae.appraisalid = a.id)
+                WHERE a.status = ? AND timescheduled > 0 AND triggered = 0";
+        $events = $DB->get_records_sql($sql, array(appraisal::STATUS_ACTIVE));
+        foreach ($events as $id => $eventdata) {
+            $event = new appraisal_message($id);
+            if ($event->is_time($time)) {
+                $event->send();
+            }
+        }
+    }
+
+}
diff --git a/totara/appraisal/cron.php b/totara/appraisal/cron.php
index 5488093..44fc485 100644
--- a/totara/appraisal/cron.php
+++ b/totara/appraisal/cron.php
@@ -28,11 +28,22 @@ require_once($CFG->dirroot.'/totara/appraisal/lib.php');
  * Run cron for appraisal
  */
 function appraisal_cron($time = 0) {
+    global $DB;
+
     // Execute the cron if Appraisals are not disabled.
     if (!totara_feature_disabled('appraisals')) {
+
+        // Update learner assignments for active appraisals.
+        $appraisals = $DB->get_records('appraisal', array('status' => appraisal::STATUS_ACTIVE));
+        foreach ($appraisals as $app) {
+            $appraisal = new appraisal($app->id);
+            $appraisal->check_assignment_changes();
+        }
+
+        // Send scheduled appraisals messages.
         if (!$time) {
             $time = time();
         }
-        appraisal_event_handler::send_scheduled($time);
+        totara_appraisal_observer::send_scheduled($time);
     }
 }
diff --git a/totara/appraisal/db/events.php b/totara/appraisal/db/events.php
index 187b769..facdb9e 100644
--- a/totara/appraisal/db/events.php
+++ b/totara/appraisal/db/events.php
@@ -34,17 +34,14 @@ if (!defined('MOODLE_INTERNAL')) {
 $observers = array(
     array(
         'eventname' => '\totara_appraisal\event\appraisal_activation',
-        'callback'=> 'appraisal_event_handler::appraisal_activation',
-        'includefile' => '/totara/appraisal/lib.php',
+        'callback' => 'totara_appraisal_observer::appraisal_activation',
     ),
     array(
         'eventname' => '\totara_appraisal\event\appraisal_stage_completion',
-        'callback'=> 'appraisal_event_handler::appraisal_stage_completion',
-        'includefile' => '/totara/appraisal/lib.php',
+        'callback' => 'totara_appraisal_observer::appraisal_stage_completion',
     ),
     array(
         'eventname' => '\core\event\user_deleted',
-        'callback'=> 'appraisal_event_handler::appraisal_user_deleted',
-        'includefile' => '/totara/appraisal/lib.php',
+        'callback' => 'totara_appraisal_observer::user_deleted',
     ),
 );
diff --git a/totara/appraisal/db/upgrade.php b/totara/appraisal/db/upgrade.php
index 1079ffc..b4ae13a 100644
--- a/totara/appraisal/db/upgrade.php
+++ b/totara/appraisal/db/upgrade.php
@@ -28,6 +28,8 @@
  */
 
 require_once($CFG->dirroot.'/totara/core/db/utils.php');
+require_once($CFG->dirroot.'/totara/appraisal/lib.php');
+
 /**
  * Local database upgrade script
  *
@@ -80,7 +82,7 @@ function xmldb_totara_appraisal_upgrade($oldversion) {
                             'mnethostid' => $user->mnethostid
                         )
                 ));
-                appraisal_event_handler::appraisal_user_deleted($event);
+                totara_appraisal_observer::user_deleted($event);
                 $i++;
                 $pbar->update($i, $usercount, "Fixing Appraisals for deleted users - {$i}/{$usercount}.");
             }
@@ -89,85 +91,68 @@ function xmldb_totara_appraisal_upgrade($oldversion) {
         upgrade_plugin_savepoint(true, 2014061600, 'totara', 'appraisal');
     }
 
-    if ($oldversion < 2014062000) {
-        $users = $DB->get_records('user', array('deleted' => 1));
-        $users = array_keys($users);
-
-        $transaction = $DB->start_delegated_transaction();
-
-        if (!empty($users)) {
-            list($insql, $inparam) = $DB->get_in_or_equal($users);
-            $now = time();
-
-            // First try and complete the stage so the user can continue the appraisal.
-            $sql = "SELECT ara.*, aua.activestageid, aua.appraisalid, aua.userid AS subjectid
-                      FROM {appraisal_role_assignment} ara
-                      JOIN {appraisal_user_assignment} aua
-                        ON ara.appraisaluserassignmentid = aua.id
-                     WHERE ara.userid {$insql}";
-            $roleassignments = $DB->get_records_sql($sql, $inparam);
-
-            $completionsql = "SELECT 1
-                                FROM {appraisal_role_assignment} ara
-                           LEFT JOIN {appraisal_stage_data} asd
-                                  ON asd.appraisalroleassignmentid = ara.id
-                                 AND asd.appraisalstageid = ?
-                               WHERE ara.appraisaluserassignmentid = ?
-                                 AND ara.userid <> 0
-                                 AND asd.timecompleted IS NULL";
-
-            $todb = new stdClass();
-            $todb->timecompleted = $now;
-            foreach ($roleassignments as $role) {
-                $todb->appraisalroleassignmentid = $role->id;
-                $todb->appraisalstageid = $role->activestageid;
-                $DB->insert_record('appraisal_stage_data', $todb);
-
-                // Check if all assigned roles have completed the appraisal.
-                if (!$DB->record_exists_sql($completionsql, array($role->activestageid, $role->appraisaluserassignmentid))) {
-                    $stages = $DB->get_records('appraisal_stage', array('appraisalid' => $role->appraisalid), 'timedue, id');
-
-                    // Find the next stage.
-                    $currentstage = reset($stages);
-                    for ($i = 0; $i < count($stages) - 1; $i++) {
-                        if ($currentstage->id == $role->activestageid) {
-                            $currentstage = next($stages);
-                            $nextstageid = $currentstage->id;
-                            break;
-                        }
-                        $currentstage = next($stages);
-                    }
-
-                    // Move to the next stage or mark the appraisal as complete.
-                    if (!empty($nextstageid)) {
-                        $DB->set_field('appraisal_user_assignment', 'activestageid', $nextstageid,
-                            array('userid' => $role->subjectid, 'appraisalid' => $role->appraisalid));
-                        $nextstageid = 0;
-                    } else {
-                        // Mark the user as complete for this appraisal.
-                        $DB->set_field('appraisal_user_assignment', 'timecompleted', $now, array('id' => $role->appraisaluserassignmentid));
-
-                        // Check if all users are complete.
-                        $unfinished = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $role->appraisalid, 'timecompleted' => null));
-                        if (!$unfinished) {
-                            // Mark this appraisal as complete.
-                            $DB->set_field('appraisal', 'status', appraisal::STATUS_COMPLETED, array('id' => $role->appraisalid));
-                            $DB->set_field('appraisal', 'timefinished', $now, array('id' => $role->appraisalid));
-                        }
-                    }
-                }
+    if ($oldversion < 2014062300) {
+        $table = new xmldb_table('appraisal_user_assignment');
+        $field = new xmldb_field('status', XMLDB_TYPE_INTEGER, '10', null, XMLDB_NOTNULL, null, 0);
+
+        if (!$dbman->field_exists($table, $field)) {
+            $transaction = $DB->start_delegated_transaction();
+
+            $dbman->add_field($table, $field);
+
+            // Migrate status from appraisal status.
+            $appraisals = $DB->get_records('appraisal');
+            foreach ($appraisals as $appraisal) {
+                $sql = "UPDATE {appraisal_user_assignment} SET status = ? WHERE appraisalid = ?";
+                $params = array($appraisal->status, $appraisal->id);
+                $DB->execute($sql, $params);
             }
 
-            // Then flag all the role_assignments as empty.
-            $sql = "UPDATE {appraisal_role_assignment}
-                       SET userid = 0
-                       WHERE userid {$insql}";
-            $DB->execute($sql, $inparam);
+            // Finally set the status for all completed users at once.
+            $sql = "UPDATE {appraisal_user_assignment} SET status = ? WHERE timecompleted IS NOT NULL";
+            $params = array(appraisal::STATUS_COMPLETED);
+            $DB->execute($sql, $params);
+
+            $transaction->allow_commit();
         }
 
-        $transaction->allow_commit();
+        upgrade_plugin_savepoint(true, 2014062300, 'totara', 'appraisal');
+    }
+
+    if ($oldversion < 2014062301) {
+
+        // Define table appraisal_role_changes to be created.
+        $table = new xmldb_table('appraisal_role_changes');
+
+        // Adding fields to table appraisal_role_changes.
+        $table->add_field('id', XMLDB_TYPE_INTEGER, '10', null, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
+        $table->add_field('userassignmentid', XMLDB_TYPE_INTEGER, '10', null, XMLDB_NOTNULL, null, null);
+        $table->add_field('originaluserid', XMLDB_TYPE_INTEGER, '10', null, null, null, null);
+        $table->add_field('newuserid', XMLDB_TYPE_INTEGER, '10', null, null, null, null);
+        $table->add_field('role', XMLDB_TYPE_INTEGER, '3', null, XMLDB_NOTNULL, null, null);
+        $table->add_field('timecreated', XMLDB_TYPE_INTEGER, '10', null, XMLDB_NOTNULL, null, 0);
+
+        // Adding keys to table appraisal_role_changes.
+        $table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
+
+        // Conditionally launch create table for appraisal_role_changes.
+        if (!$dbman->table_exists($table)) {
+            $dbman->create_table($table);
+        }
+
+        upgrade_plugin_savepoint(true, 2014062301, 'totara', 'appraisal');
+    }
+
+    if ($oldversion < 2014062302) {
+        // Adding a timecreated field to appraisals role assignments.
+        $table = new xmldb_table('appraisal_role_assignment');
+        $field = new xmldb_field('timecreated', XMLDB_TYPE_INTEGER, '10', null, XMLDB_NOTNULL, null, 0);
+
+        if (!$dbman->field_exists($table, $field)) {
+            $dbman->add_field($table, $field);
+        }
 
-        upgrade_plugin_savepoint(true, 2014062000, 'totara', 'appraisal');
+        upgrade_plugin_savepoint(true, 2014062302, 'totara', 'appraisal');
     }
 
     return true;
diff --git a/totara/appraisal/general.php b/totara/appraisal/general.php
index 9697ba6..2d069e1 100644
--- a/totara/appraisal/general.php
+++ b/totara/appraisal/general.php
@@ -79,6 +79,10 @@ if ($fromform = $mform->get_data()) {
     }
 }
 
+$title = $PAGE->title . ': ' . $appraisal->name;
+$PAGE->set_title($title);
+$PAGE->set_heading($appraisal->name);
+$PAGE->navbar->add($appraisal->name);
 $output = $PAGE->get_renderer('totara_appraisal');
 echo $output->header();
 if ($appraisal->id) {
diff --git a/totara/appraisal/lang/en/totara_appraisal.php b/totara/appraisal/lang/en/totara_appraisal.php
index 2530379..27c419e 100644
--- a/totara/appraisal/lang/en/totara_appraisal.php
+++ b/totara/appraisal/lang/en/totara_appraisal.php
@@ -54,8 +54,11 @@ $string['appraisalactivenochangesallowed'] = 'This appraisal is active, no chang
 $string['appraisalcloned'] = 'Appraisal Cloned';
 $string['appraisalclosed'] = 'Appraisal \'{$a}\' closed';
 $string['appraisalclosedalertssent'] = 'Appraisal \'{$a}\' closed and alert have been sent';
+$string['appraisalclosedforuser'] = 'This appraisal has been closed because {$a} is no longer assigned.';
+$string['appraisalclosednochangesallowed'] = 'This appraisal is closed, no changes can be made to learner assignments';
 $string['appraisalsdisabled'] = 'Appraisals are not enabled on this site';
 $string['appraisalfixerrors'] = 'You must fix the following errors prior to appraisal activation:';
+$string['appraisalfixwarnings'] = 'Fixing the following warnings is also recommended:';
 $string['appraisalhasstages'] = 'Appraisal has the following stages:';
 $string['appraisalhistory'] = 'appraisal history';
 $string['appraisalinvalid'] = 'Appraisal not ready for activation';
@@ -86,6 +89,8 @@ $string['assignments'] = 'Assignments';
 $string['assignnumusers'] = 'Learners';
 $string['assignsourcename'] = 'Assigned Group';
 $string['backtoappraisal'] = 'Back to appraisal';
+$string['cancelled'] = 'Cancelled';
+$string['changesnotlive'] = 'Changes within the assigned groups have occurred but are not yet live. Appraisal assignments will be updated on the next cron run';
 $string['changessaved'] = 'Changes saved';
 $string['close'] = 'Close';
 $string['closeappraisal'] = 'Close appraisal';
@@ -115,8 +120,10 @@ $string['configenableappraisals'] = 'This option will let you: Enable(show)/Hide
 * If Disable is chosen, appraisals will disappear from any menu on the site and will not be accessible.
 ';
 $string['confirmactivateappraisal'] = 'Do you really want to activate this appraisal?';
+$string['confirmactivatewarning'] = 'You can activate the appraisal without fixing these warnings, but users may encounter some issues. Do you really want to activate this appraisal?';
 $string['confirmcloseappraisal'] = 'Do you really want to close this appraisal?';
 $string['confirmdeleteappraisal'] = 'Do you really want to remove this appraisal?';
+$string['confirmdeletegroup'] = 'Do you really want to remove the {$a->grouptype} "{$a->groupname}" from appraisal "{$a->appraisalname}"? This will close assignments for any users not currently assigned via other group assignments.';
 $string['confirmdeletemessage'] = 'Do you really want to remove this message?';
 $string['confirmdeletepage'] = 'Do you really want to remove this page?';
 $string['confirmdeletestage'] = 'Do you really want to remove this stage?';
@@ -148,6 +155,7 @@ $string['downloadnow'] = 'Download now';
 $string['draft'] = 'Draft';
 $string['editpageheading'] = 'Edit page';
 $string['editstageheading'] = 'Edit stage';
+$string['emptyassignments'] = 'Due to be removed';
 $string['enableappraisals'] = 'Enable Appraisals';
 $string['example:appraisalname'] = 'Example appraisal';
 $string['example:appraisaldescription'] = '<p>This is an example appraisal. You can use this as a starting point for building your own appraisal or just browse around to see how the functionality works.</p><p>If you don\'t need it, just delete it and create your own.</p>';
@@ -198,10 +206,12 @@ $string['error:dialognotreeitemsevidencefromplan'] = 'There is no linked evidenc
 $string['error:dialognotreeitemsgoals'] = 'No goals in this framework';
 $string['error:dialognotreeitemsobjfromplan'] = 'There are no objectives in this plan';
 $string['error:dialognotreeitemsprogfromplan'] = 'There are no programs in this plan';
+$string['error:invalidgrouptype'] = 'Unrecognised group type';
 $string['error:messagetitleyrequired'] = 'Message title is required';
 $string['error:messagebodyrequired'] = 'Message body is required';
 $string['error:nopermissions'] = 'You do not have permissions to perform that action';
 $string['error:pagenotfound'] = 'Page not found';
+$string['error:pagepermissions'] = 'You do not have permissions to view this page';
 $string['error:redisplayoutoforder'] = 'Redisplay question must be placed on a page after the question it links to';
 $string['error:stagenotfound'] = 'Stage not found';
 $string['error:submitteddatainvalid'] = 'There were problems with the data you submitted';
@@ -262,6 +272,12 @@ $string['messageevent'] = 'Event';
 $string['messagetiming'] = 'Timing';
 $string['messagerecipients'] = 'Recipients';
 $string['messagesaved'] = 'Message saved';
+$string['missingroles'] = 'Some assigned users are missing important role assignments.';
+$string['missingrolesbelow'] = ' Users may not be able to complete the appraisal without these roles, they are listed below:';
+$string['missingrolesinfo'] = 'Some assigned users are missing important role assignments. {$a}';
+$string['missingroleslink'] = 'View full list of missing roles';
+$string['missingrolesnone'] = 'There are no missing roles for the user assignments of this appraisal.';
+$string['missingrolestitle'] = 'Appraisals Missing Roles - {$a}';
 $string['myappraisals'] = 'My Appraisals';
 $string['myteamappraisals'] = 'My Team\'s Appraisals';
 $string['name'] = 'Name';
@@ -313,18 +329,20 @@ $string['roleaccessnotice'] = 'If a role cannot answer or view other\'s answers
 $string['roleadministrator'] = 'Administrator';
 $string['roleappraiser'] = 'Appraiser';
 $string['roleall'] = 'All';
-$string['rolecurrentlyempty'] = 'Role currently empty';
-$string['rolelearner'] = 'Learner';
-$string['rolemanager'] = 'Manager';
-$string['roleteamlead'] = 'Manager\'s Manager';
 $string['rolecompleteyou'] = ' You must complete this stage';
 $string['rolecompleteyour'] = ' Your {$a} must complete this stage';
 $string['rolecompleteuser'] = ' {$a} must complete this stage';
 $string['rolecompleteusers'] = ' {$a->username}\'s {$a->rolename} must complete this stage';
+$string['rolecurrentlyempty'] = 'Role currently empty';
+$string['rolehaschanged'] = 'This role is due to change';
+$string['rolelearner'] = 'Learner';
+$string['rolemanager'] = 'Manager';
 $string['rolescananswer'] = 'Roles that can answer';
 $string['rolescananswer_help'] = 'These are the roles that can answer at least one question on a page within this stage.';
 $string['rolescanview'] = 'Roles that can view';
 $string['rolescanview_help'] = 'These are the roles that can view at least one other person\'s answer but cannot answer any questions themselves.';
+$string['rolesmissing'] = 'Warning: there are missing roles which may prevent this appraisal being completed.';
+$string['roleteamlead'] = 'Manager\'s Manager';
 $string['reports'] = 'Reports';
 $string['savechanges'] = 'Save changes';
 $string['savepdfsnapshot'] = 'Save PDF Snapshot';
@@ -355,6 +373,8 @@ $string['statusreport'] = 'Status report';
 $string['statusreportforx'] = '{$a} status report: ';
 $string['temporarypage'] = 'Temporary page';
 $string['unavailable'] = 'Unavailable';
+$string['update'] = 'Update';
+$string['updatenow'] = 'Update Now';
 $string['view'] = 'View';
 $string['viewother'] = 'View other role\'s answers';
 $string['viewreport'] = 'View report';
diff --git a/totara/appraisal/learners.php b/totara/appraisal/learners.php
index 3e35d7c..a0836cb 100644
--- a/totara/appraisal/learners.php
+++ b/totara/appraisal/learners.php
@@ -33,6 +33,7 @@ appraisal::check_feature_enabled();
 
 // Get the appraisal id.
 $appraisalid = required_param('appraisalid', PARAM_INT);
+$update = optional_param('update', false, PARAM_BOOL);
 $module = 'appraisal';
 $appraisal = new appraisal($appraisalid);
 $assign = new totara_assign_appraisal($module, $appraisal);
@@ -42,37 +43,82 @@ $systemcontext = context_system::instance();
 $canassign = has_capability('totara/appraisal:assignappraisaltogroup', $systemcontext);
 $canviewusers = has_capability('totara/appraisal:viewassignedusers', $systemcontext);
 
+admin_externalpage_setup('manageappraisals');
+$title = $PAGE->title . ': ' . $appraisal->name;
+$PAGE->set_title($title);
+$PAGE->set_heading($appraisal->name);
+$PAGE->navbar->add($appraisal->name);
+$output = $PAGE->get_renderer('totara_appraisal');
+
+$grouptypes = $assign->get_assignable_grouptype_names();
+$returnparams = array('appraisalid' => $appraisalid);
+$returnurl = new moodle_url('/totara/appraisal/learners.php', $returnparams);
+
 $deleteid = optional_param('deleteid', null, PARAM_ALPHANUMEXT);
-if ($deleteid && $canassign && ($appraisal->status == appraisal::STATUS_DRAFT)) {
+$confirm = optional_param('confirm', false, PARAM_BOOL);
+if ($deleteid && $canassign && (!appraisal::is_closed($appraisalid))) {
+    list($grp, $aid) = explode("_", $deleteid);
+
+    if (appraisal::is_active($appraisalid) && !$confirm) {
+
+        $deleteparams = array('appraisalid' => $appraisalid, 'deleteid' => $deleteid, 'confirm' => true, 'sesskey' => sesskey());
+        $deleteurl = new moodle_url('/totara/appraisal/learners.php', $deleteparams);
+
+        $confirmparams = new stdClass();
+        $confirmparams->grouptype = $grouptypes[$grp];
+        $confirmparams->groupname = $assign->get_group_instance_name($grp, $aid);
+        $confirmparams->appraisalname = $appraisal->name;
+        $confirmstr = get_string('confirmdeletegroup', 'totara_appraisal', $confirmparams);
+
+        echo $output->header();
+        echo $output->confirm($confirmstr, $deleteurl, $returnurl);
+        echo $output->footer();
+
+        exit();
+    } else {
+        if (!confirm_sesskey()) {
+            print_error('confirmsesskeybad', 'error');
+        }
+        $assign->delete_assigned_group($grp, $aid);
+        redirect($returnurl);
+    }
+}
+
+if ($update && $canassign) {
     if (!confirm_sesskey()) {
         print_error('confirmsesskeybad', 'error');
     }
-    list($grp, $aid) = explode("_", $deleteid);
-    $assign->delete_assigned_group($grp, $aid);
+
+    $appraisal->check_assignment_changes();
+    redirect($returnurl);
 }
 
-admin_externalpage_setup('manageappraisals');
+$notlivenotice = $output->display_notlive_notice($appraisalid, $canassign);
 // Setup the JS.
-totara_setup_assigndialogs($module, $appraisalid, $canviewusers);
-$output = $PAGE->get_renderer('totara_appraisal');
+totara_setup_assigndialogs($module, $appraisalid, $canviewusers, $notlivenotice);
 echo $output->header();
 if ($appraisal->id) {
     echo $output->heading($appraisal->name);
     echo $output->appraisal_additional_actions($appraisal->status, $appraisal->id);
 }
 
+if ($appraisal->status == appraisal::STATUS_ACTIVE) {
+    $warnings = $appraisal->validate_roles(true);
+    echo $output->display_learner_warnings($appraisal->id, $warnings, $canviewusers);
+}
+
 echo $output->appraisal_management_tabs($appraisal->id, 'learners');
 
 echo $output->heading(get_string('assigncurrentgroups', 'totara_appraisal'));
 
 if ($canassign) {
-    if ($appraisal->status == appraisal::STATUS_DRAFT) {
+    if ($appraisal->status == appraisal::STATUS_CLOSED) {
+        echo get_string('appraisalclosednochangesallowed', 'totara_appraisal');
+    } else {
         $options = array_merge(array("" => get_string('assigngroup', 'totara_core')),
-                $assign->get_assignable_grouptype_names());
+                $grouptypes);
         echo html_writer::select($options, 'groupselector', null, null,
                 array('class' => 'group_selector', 'itemid' => $appraisalid));
-    } else {
-        echo get_string('appraisalactivenochangesallowed', 'totara_appraisal');
     }
 }
 
@@ -82,8 +128,21 @@ echo $output->display_assigned_groups($currentassignments, $appraisalid);
 
 echo $output->heading(get_string('assigncurrentusers', 'totara_appraisal'));
 
+// If the appraisal is active notify the user that changes are not live.
+if ($appraisal->status == appraisal::STATUS_ACTIVE) {
+    $userassignments = $assign->get_current_users();
+    $groupassignments = $assign->get_current_users(null, null, null, true);
+    $differences = $appraisal->compare_assignments($userassignments, $groupassignments);
+    echo html_writer::start_tag('div', array('id' => 'notlivenotice'));
+    if ($differences) {
+        echo $notlivenotice;
+    }
+    echo html_writer::end_tag('div');
+}
+
 if ($canviewusers) {
     echo $output->display_user_datatable();
 }
 
+
 echo $output->footer();
